// Include files
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Defines
#define MYAPP "[simpleFork1]"
#define PARENT "<parent>"
#define CHILD  "<child>"

// Main function
int main(int argc, char **argv)
{
  pid_t pid;
  char pMsg[]=PARENT;
  char cMsg[]=CHILD;
  char *p;
  
  printf("%s Process ID is %d\n",MYAPP,(int)getpid());
  printf("%s Parent process ID is %d\n\n",MYAPP,(int)getppid());

  pid=fork();
  switch (pid) {
  case 0: // child process
    p=cMsg;
    break;
  case -1: // error in fork()
    perror(MYAPP "Error calling fork: ");
    break;
  default: // parent process
    p=pMsg;    
    break;
  }

  // following code is executed by both parent and child processes
  printf("%s%s Return code from fork: %d\n",MYAPP,p,pid);
  //sleep(1);
  printf("%s%s Process ID is %d\n",MYAPP,p,(int)getpid());
  //sleep(1);
  printf("%s%s Parent Process ID is %d\n",MYAPP,p,(int)getppid());

  exit(EXIT_SUCCESS);
}
