// Include files
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Defines
#define MYAPP "[simpleFork4]"
#define NLOOP 10

// Main function
int main(int argc, char **argv)
{
  pid_t pid;
  char msg[2];
  char ch;
  int fd;
  int nw;
  int i,j;
  double a;
 
  if (argc!=2) {
    printf("Usage: %s outfile\n",argv[0]);
    exit(0);
  }

  pid=fork();
  switch (pid) {
  case 0: // child process
    msg[0]='C';
    break;
  case -1: // error in fork()
    perror(MYAPP "Error calling fork: ");
    break;
  default: // parent process
    msg[0]='P';    
    break;
  }

  //-----------------------
  printf("%s (%d): opening file \"%s\" using O_WRONLY ...\n",
	 MYAPP,pid,argv[1]);
  if ((fd=open(argv[1],O_WRONLY | O_CREAT,0660)) == -1) {
    perror(MYAPP "Error calling open: ");
  }
  else {
    printf("%s: file has been opened with fd=%d\n",MYAPP,fd);
  }

  for (i=0;i<NLOOP;i++) {
    for (ch='a';ch<='z';ch++) {
      msg[1]=ch;
      if ((nw=write(fd,msg,2)) != 2)
	perror(MYAPP "ERROR in write");
    }
    if ((nw=write(fd,"\n",1)) != 1)
      perror(MYAPP "ERROR in write");

    for (j=0;j<100000;j++)
      a = a*a-(a+1)/(a-1);
  }

  printf("%s (%d): closing file with fd=%d\n",MYAPP,pid,fd);
  close(fd);

  exit(EXIT_SUCCESS);
}
